--[[
converts all weapons into rocket launchers, and all ammo into rockets

requires Aleph One 0.23

copyright 2010 Gregory Smith

you are free to distribute this script, but if you modify it, you must
change the name
]]

Triggers = {}

if Game.version < "20100118" then
   Triggers.idle = function()
		      if Game.ticks % 30 == 0 then
			 for p in Players() do
			    if p.local_ then
			       p:print("This script requires Aleph One 0.23. Game will end in " .. (10 - (Game.ticks / 30)) .. " seconds")
			    end
			 end
		      end
		      if Game.ticks > 300 then
			 Game.over = true
		      end
		   end
else
   Game.proper_item_accounting = true
end

function item_type_is_ammo(type)
   return type == "pistol ammo" 
      or type == "fusion pistol ammo"
      or type == "assault rifle ammo"
      or type == "assault rifle grenades"
      or type == "missile launcher ammo"
      or type == "alien weapon ammo"
      or type == "flamethrower ammo"
      or type == "shotgun ammo"
      or type == "smg ammo"
end

function item_is_ammo(item)
   return item_type_is_ammo(item.type)
end

function item_type_is_weapon(type)
   return type == "pistol"
      or type == "fusion pistol"
      or type == "assault rifle"
      or type == "missile launcher"
      or type == "alien weapon"
      or type == "flamethrower"
      or type == "shotgun"
      or type == "smg"
end


function item_is_weapon(item)
   return item_type_is_weapon(item.type)
end

ammo_type = "missile launcher ammo"
weapon_type = "missile launcher"

function replace_player_weapons_ammo(player)
   for it in ItemTypes() do
      if item_type_is_ammo(it) and it ~= ammo_type then
	 player.items[ammo_type] = player.items[ammo_type] + player.items[it]
	 player.items[it] = 0
      elseif item_type_is_weapon(it) and it ~= weapon_type then
	 player.items[weapon_type] = player.items[weapon_type] + player.items[it]
	 player.items[it] = 0
      end
   end
   player.weapons[weapon_type]:select()
end

function replace_ammo(item)
   new_item = Items.new(item.x, item.y, item.z - item.polygon.z, item.polygon, ammo_type)
   item:delete()
end

function replace_weapon(item)
   new_item = Items.new(item.x, item.y, item.z - item.polygon.z, item.polygon, weapon_type)
   item:delete()
end

function Triggers.item_created(item)
   if item.type == ammo_type or item.type == weapon_type then
      return
   end
   if item_is_ammo(item) then
      replace_ammo(item)
   elseif item_is_weapon(item) then
      replace_weapon(item)
   end
end

function Triggers.init()
   for item in Items() do
      if item_is_ammo(item) then
	 replace_ammo(item)
      elseif item_is_weapon(item) then
	 replace_weapon(item)
      end
   end
   for p in Players() do
      replace_player_weapons_ammo(p)
   end
end

function Triggers.player_revived(p)
   replace_player_weapons_ammo(p)
end